SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell commentStamp: 'CV 7/15/2012 14:39' prior: 0!
"Quinto game - exercise of Squeak by Example - cell of the game"!

!SBECell methodsFor: 'initialization' stamp: 'CV 7/15/2012 14:43'!
initialize
	"initialization of an SBECell"
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'accessing' stamp: 'CV 7/15/2012 15:20'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'event handling' stamp: 'CV 7/15/2012 15:22'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame commentStamp: 'CV 7/15/2012 14:53' prior: 0!
"The class representing the borad game of Quinto"!

!SBEGame methodsFor: 'initialization' stamp: 'CV 7/15/2012 15:02'!
cellsPerSide
	"The number of cells along each side of the game"
	^10! !

!SBEGame methodsFor: 'initialization' stamp: 'CV 7/15/2012 14:58'!
initialize
	"Initializing the SBEGame"
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n)@(height*n)) + (2* self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!SBEGame methodsFor: 'initialization' stamp: 'CV 7/15/2012 15:27'!
newCellAt: i at:j
	"Create a cell for position (i,j) and add it to my on-screen
	 representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j-1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j ].
	^ c! !

!SBEGame methodsFor: 'game logic' stamp: 'CV 7/15/2012 15:16'!
toggleNeighboursOfCellAt: i at: j
	"toggles the state of the for cells (to the N, S, W, E) of the cell"
	(i > 1) ifTrue: [(cells at: i - 1 at: j) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i+1 at: j) toggleState].
	(j > 1) ifTrue: [(cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [(cells at: i at: j+1) toggleState].! !
